VERSION 5.00
Begin VB.Form CreateMessageForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Create Message"
   ClientHeight    =   3960
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6135
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   264
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   409
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton uxSendButton 
      Caption         =   "Send"
      Height          =   375
      Left            =   4800
      TabIndex        =   8
      Top             =   3480
      Width           =   1215
   End
   Begin VB.TextBox uxSMS 
      Height          =   2535
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   7
      Top             =   840
      Width           =   5895
   End
   Begin VB.OptionButton uxHex8 
      Caption         =   "8-Bit Hex"
      Height          =   255
      Left            =   5040
      TabIndex        =   6
      Top             =   480
      Width           =   975
   End
   Begin VB.OptionButton uxHex7 
      Caption         =   "7-Bit Hex"
      Height          =   255
      Left            =   3960
      TabIndex        =   5
      Top             =   480
      Width           =   975
   End
   Begin VB.OptionButton uxText 
      Caption         =   "Text"
      Height          =   255
      Left            =   3120
      TabIndex        =   4
      Top             =   480
      Width           =   735
   End
   Begin VB.TextBox uxToValue 
      Height          =   285
      Left            =   1320
      TabIndex        =   3
      Top             =   480
      Width           =   1335
   End
   Begin VB.Label uxFromValue 
      Height          =   255
      Left            =   1320
      TabIndex        =   2
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label uxToLabel 
      Caption         =   "To:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label uxFromLabel 
      Caption         =   "From:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "CreateMessageForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'************************************************
'* MultiModem Demo Application - CreateMessageForm
'* Environment: Visual Basic 6
'* Programmer: Sam Javner
'* Date: 4/29/2007
'*
'* Summary: Used to create and send a message.
'* Form is displayed from uxCreateButton_Click() in MainForm
'************************************************


'Explicitly declare all variables
Option Explicit


'************************************************
'* Private Sub Form_Load()
'* Summary:     Occurs when form is loaded, set default SMS mode to text mode
'************************************************
Private Sub Form_Load()

    uxText.Value = True

End Sub



'************************************************
'* Private Sub uxText_Click()
'* Summary:     Occurs when text radio button is clicked
'*              Set maximum length to 160 characters
'************************************************
Private Sub uxText_Click()

    If Len(uxSMS.Text) > 160 Then uxSMS.Text = Left(uxSMS.Text, 160)
    uxSMS.MaxLength = 160

End Sub



'************************************************
'* Private Sub uxHex7_Click()
'* Summary:     Occurs when hex 7-bit radio button is clicked
'*              Set maximum length to 320 characters
'*              (160 x 2 bytes per hex representation of a character)
'************************************************
Private Sub uxHex7_Click()

    If Len(uxSMS.Text) > 320 Then uxSMS.Text = Left(uxSMS.Text, 320)
    uxSMS.MaxLength = 320
    
End Sub



'************************************************
'* Private Sub uxHex8_Click()
'* Summary:     Occurs when hex 8-bit radio button is clicked
'*              Set maximum length to 280 characters
'*              (140 x 2 bytes per hex representation of a character)
'************************************************
Private Sub uxHex8_Click()

    If Len(uxSMS.Text) > 280 Then uxSMS.Text = Left(uxSMS.Text, 280)
    uxSMS.MaxLength = 280
    
End Sub



'************************************************
'* Private Sub uxSendButton_Click()
'* Summary:     Attempts to send the message.
'************************************************
Private Sub uxSendButton_Click()

        Dim number As String
        Dim msg As String
        Dim i As Integer
        'Dim c As Char
        
        'Remove dashes from the phone number
        number = uxToValue.Text
        While InStr(number, "-") > 0
            number = Left(number, InStr(number, "-") - 1) & Mid(number, InStr(number, "-") + 1)
        Wend
        
        If Len(number) = 0 Then
            MsgBox "To field must not be blank", vbExclamation, "MultiModem Demo Application"
            Exit Sub
        End If
        
        msg = uxSMS.Text
        
        If uxText.Value = True Then
        
            'Set text mode
            If Not MainForm.MM.SetCharacterSet("PCCP437") Then
                MsgBox "Error setting character set", vbExclamation, "MultiModem Demo Application"
                Exit Sub
            End If
            
            'Send text mode message
            If MainForm.MM.SendMessage(number, msg) Then
                Unload Me
            Else
                MsgBox "Error sending message", vbExclamation, "MultiModem Demo Application"
                Exit Sub
            End If
        
        ElseIf uxHex7.Value = True Then
        
            'Set hex mode
            If Not MainForm.MM.SetCharacterSet("HEX") Then
                MsgBox "Error setting character set", vbExclamation, "MultiModem Demo Application"
                Exit Sub
            End If
            
            'Send text mode message (with hex representation)
            If MainForm.MM.SendMessage(number, msg) Then
                Unload Me
            Else
                MsgBox "Error sending message", vbExclamation, "MultiModem Demo Application"
            End If
            
            Unload Me
        
        ElseIf uxHex8.Value = True Then
        
            'Send PDU mode message
            If MainForm.MM.SendMessageTPDU(number, msg) Then
                Unload Me
            Else
                MsgBox "Error sending message", vbExclamation, "MultiModem Demo Application"
            End If
            
            Unload Me
        
        End If
        
End Sub











