VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "MultiModem Demo Application"
   ClientHeight    =   6540
   ClientLeft      =   150
   ClientTop       =   840
   ClientWidth     =   10560
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   436
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   704
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer SignalQualityTimer 
      Enabled         =   0   'False
      Interval        =   2500
      Left            =   120
      Top             =   5640
   End
   Begin VB.PictureBox uxSignalBox 
      BorderStyle     =   0  'None
      Height          =   255
      Left            =   9840
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   25
      TabIndex        =   10
      Top             =   120
      Width           =   375
   End
   Begin VB.CheckBox uxAutoReply 
      Caption         =   "Auto-Reply"
      Height          =   255
      Left            =   8520
      TabIndex        =   9
      Top             =   180
      Width           =   1215
   End
   Begin VB.Timer CheckListMessagesTimer 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   600
      Top             =   5160
   End
   Begin VB.Timer CheckMessagesTimer 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   120
      Top             =   5160
   End
   Begin VB.ComboBox uxSerialPortList 
      Height          =   315
      Left            =   1440
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   150
      Width           =   1215
   End
   Begin VB.CommandButton uxDisconnectButton 
      Caption         =   "Disconnect"
      Height          =   375
      Left            =   4080
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton uxConnectButton 
      Caption         =   "Connect"
      Height          =   375
      Left            =   2760
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton uxViewButton 
      Caption         =   "View"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   1440
      Width           =   1215
   End
   Begin VB.CommandButton uxCreateButton 
      Caption         =   "Create"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton uxDeleteButton 
      Caption         =   "Delete"
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   2400
      Width           =   1215
   End
   Begin VB.CommandButton uxRefreshButton 
      Caption         =   "Refresh"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   1215
   End
   Begin MSComctlLib.ListView uxMessageList 
      Height          =   5475
      Left            =   1440
      TabIndex        =   7
      Top             =   600
      Width           =   9015
      _ExtentX        =   15901
      _ExtentY        =   9657
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.Label uxSignalLabel 
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   10200
      TabIndex        =   11
      Top             =   120
      Width           =   255
   End
   Begin VB.Label uxStatusBar 
      Height          =   300
      Left            =   120
      TabIndex        =   8
      Top             =   6240
      Width           =   10455
   End
   Begin VB.Menu uxFileMenuItem 
      Caption         =   "&File"
      Begin VB.Menu uxFileExitMenuItem 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu uxSynchronizeClockMenuItem 
      Caption         =   "&Synchronize Clock"
   End
   Begin VB.Menu uxInfoMenuItem 
      Caption         =   "&Info"
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'************************************************
'* MultiModem Demo Application - MainForm
'* Environment: Visual Basic 6
'* Programmer: Sam Javner
'* Date: 4/29/2007
'*
'* Summary: Demo Application implementing the use of the
'* MultiTech MultiModem using the MultiModem Class
'*
'* Note: Any visual elements on the form (buttons, labels, etc.)
'* are prefixed with "ux" (user experience) so that they appear
'* together in the Properties dropdown list
'************************************************


'Explicitly declare all variables
Option Explicit


'Variable for instance of MultiModem Class
Public MM As MultiModem


'Variables for timeout for ListMessages
Private listMessagesLastTime As Single
Public ListMessagesTimeout As Long



'************************************************
'* Private Sub Form_Load()
'* Summary:     Occurs on form load, readies the form for use
'************************************************
Private Sub Form_Load()

    Dim i As Integer

    'Populate serial port list with COM1 - COM16
    For i = 1 To 16

        uxSerialPortList.AddItem "COM" & i

    Next i
    
    'Select COM1 as default
    uxSerialPortList.Text = "COM1"

    'Enable only the Connect Button
    uxConnectButton.Enabled = True
    uxSerialPortList.Enabled = True
    SetButtons False
    
    'Create column headers for Message List
    CreateColumnHeaders
    
    'Set MM to new instance of MultiModem object
    Set MM = New MultiModem
    
    'Set interval for Timers
    CheckMessagesTimer.Interval = 100
    SignalQualityTimer.Interval = 10000
    
    'Set timeout for ListMessages (in milliseconds)
    ListMessagesTimeout = 2000

End Sub



'************************************************
'* Private Sub Form_Unload(Cancel As Integer)
'* Summary:     Occurs on form unload, disposes of multimodem object
'************************************************
Private Sub Form_Unload(Cancel As Integer)

    'Dispose of MultiModem object
    Set MM = Nothing

End Sub



'************************************************
'* Private Sub uxFileExitMenuItem_Click()
'* Summary:     Handles File->Exit menu item which closes program
'************************************************
Private Sub uxFileExitMenuItem_Click()

    'Disconnect from serial port if connected
    If uxDisconnectButton.Enabled Then uxDisconnectButton_Click

    'Unload the form
    Unload Me

End Sub



'************************************************
'* Private Sub uxSynchronizeClockMenuItem_Click()
'* Summary:     Handles Synchronize Clock menu item which
'*              synchronizes the wireless modem's clock to the computer's
'************************************************
Private Sub uxSynchronizeClockMenuItem_Click()

    Dim clock As String
    
    'Format the time string properly for the SetClock function
    clock = Format(Now, "yy/MM/dd,hh:mm:ss")

    'Set clock and check for success
    If MM.SetClock(clock) Then
        uxStatusBar.Caption = "Clock set to: " & clock
    Else
        MsgBox "Error synchronizing clock", vbExclamation, "MultiModem Demo Application"
    End If

End Sub



'************************************************
'* Private Sub uxInfoMenuItem_Click()
'* Summary:     Handles Info menu item which displays info from wireless modem
'************************************************
Private Sub uxInfoMenuItem_Click()

    Dim subscriber As String, manufacturer As String, model As String
    Dim revision As String, serial As String, clock As String

    'Retrieve information, check for errors
    
    If Not MM.GetSubscriberNumber(subscriber) Then
        MsgBox "Error retrieving Subscriber Number", vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    If Not MM.GetManufacturerID(manufacturer) Then
        MsgBox "Error retrieving Manufacturer ID", vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    If Not MM.GetModelID(model) Then
        MsgBox "Error retrieving Model ID", vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    If Not MM.GetRevisionID(revision) Then
        MsgBox "Error retrieving Revision ID", vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    If Not MM.GetSerialNumber(serial) Then
        MsgBox "Error retrieving Serial Number", vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    If Not MM.GetClock(clock) Then
        MsgBox "Error retrieving Clock", vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    'Display information in a message box
    
    MsgBox "Subscriber ID: " & FormatPhoneNumber(subscriber) & vbCrLf & _
            "Manufacturer ID: " & manufacturer & vbCrLf & _
            "Model ID: " & model & vbCrLf & _
            "Revision ID: " & revision & vbCrLf & _
            "Serial Number: " & serial & vbCrLf & _
            "Date/Time: " & clock _
            , vbOKOnly, "MultiModem Demo Application"

End Sub



'************************************************
'* Private Sub uxConnectButton_Click()
'* Summary:     Handles Connect Button, connects to serial port
'************************************************
Private Sub uxConnectButton_Click()

    Dim port As Integer
    
    port = CInt(Mid(uxSerialPortList.Text, 4))

    'Try connecting to selected port, display message if error connecting
    If Not MM.Connect(port) Then
        MsgBox "Error connecting to port " & port, vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    'Disable echoing of AT Commands should be done immediately after connecting
    'Any other MultiModem function calls expect echoing to be disabled
    If Not MM.SetEcho(False) Then
        MsgBox "Error disabling Echo", vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    'Set New Message Indication = 1
    'If we don't do this, CheckMessages might not work
    If Not MM.SetNewMessageIndication(1) Then
        MsgBox "Error setting New Message Indication", vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    'Disable connect button
    uxConnectButton.Enabled = False
    uxSerialPortList.Enabled = False
    
    'Display message
    uxStatusBar.Caption = "Connected to port " & port
     
    'Make sure buttons are disabled
    'Don't want to be issuing commands while listing messages
    SetButtons False
    
    'List Messages
    ListMessages
    
    'Done, enable buttons
    SetButtons True
    
    'Enable Timers
    CheckMessagesTimer.Enabled = True
    SignalQualityTimer.Enabled = True
    
    SignalQualityTimer_Timer

End Sub



'************************************************
'* Private Sub uxCreateButton_Click()
'* Summary:     Handles Create Button, opens form for a new text message
'************************************************
Private Sub uxCreateButton_Click()

    Dim subscriber As String

    'Get subscriber number and update on CreateMessageForm
    MM.GetSubscriberNumber subscriber
    CreateMessageForm.uxFromValue = FormatPhoneNumber(subscriber)
    
    'Display CreateMessageForm
    CreateMessageForm.Show vbModal

End Sub



'************************************************
'* Private Sub uxDeleteButton_Click()
'* Summary:     Handles Delete Button, deletes a received text message
'************************************************
Private Sub uxDeleteButton_Click()

    Dim i As Integer
    
    'Delete message
    'If successful, remove item from Message List
    If MM.DeleteMessage(uxMessageList.SelectedItem) Then

        For i = 1 To uxMessageList.ListItems.Count
            If uxMessageList.ListItems.Item(i) = uxMessageList.SelectedItem Then
                uxMessageList.ListItems.Remove i
                Exit For
            End If
        Next i
    
    End If

End Sub



'************************************************
'* Private Sub uxDisconnectButton_Click()
'* Summary:     Handles Disconnect Button, disconnects from serial port
'************************************************
Private Sub uxDisconnectButton_Click()

    Dim port As Integer
    
    port = CInt(Mid(uxSerialPortList.Text, 4))
      
    'Disable Timers
    CheckMessagesTimer.Enabled = False
    SignalQualityTimer.Enabled = False
    uxSignalLabel = ""
    uxSignalBox.Cls
    
    'Try disconnecting, display message if error disconnecting
    If Not MM.Disconnect Then
        MsgBox "Error disconnecting from port " & port, vbExclamation, "MultiModem Demo Application"
        Exit Sub
    End If
    
    'Enable connect button and disable other buttons
    uxConnectButton.Enabled = True
    uxSerialPortList.Enabled = True
    SetButtons False
    
    'Display message
    uxStatusBar.Caption = "Disconnected from port " & port
    
    'Remove messages from list
    Dim i As Integer
    For i = uxMessageList.ListItems.Count To 1 Step -1
        uxMessageList.ListItems.Remove i
    Next i

End Sub



'************************************************
'* Private Sub uxRefreshButton_Click()
'* Summary:     Handles Refresh Button, refreshes list of text messages
'************************************************
Private Sub uxRefreshButton_Click()

    'Make sure buttons are disabled
    'Don't want to be issuing commands while listing messages
    SetButtons False
    
    'List Messages
    ListMessages
    
    'Done, enable buttons
    SetButtons True

End Sub



'************************************************
'* Private Sub uxViewButton_Click()
'* Summary:     Handles View Button, opens form to view a message in more detail
'************************************************
Private Sub uxViewButton_Click()

    Dim subscriber As String
    Dim unread As Boolean, number As String, timestamp As String, msg As String, msghex As String
    
    'Update ViewMessageForm with subscriber number
    MM.GetSubscriberNumber subscriber
    ViewMessageForm.uxToValue = FormatPhoneNumber(subscriber)

    'Read the currently selected message as text and hex
    MM.SetCharacterSet ("PCCP437")
    MM.ReadMessage uxMessageList.SelectedItem, unread, number, timestamp, msg
    MM.SetCharacterSet ("HEX")
    MM.ReadMessage uxMessageList.SelectedItem, unread, number, timestamp, msghex
    
    'Update ViewMessageForm with info from ReadMessage
    ViewMessageForm.uxFromValue = FormatPhoneNumber(number)
    ViewMessageForm.uxSMS = msg
    ViewMessageForm.uxSMSHex = msghex
    
    'Show ViewMessageForm
    ViewMessageForm.Show vbModal

End Sub



'************************************************
'* Private Sub CheckMessagesTimer_Timer()
'* Summary:     Check the message queue for any incoming messages
'************************************************
Private Sub CheckMessagesTimer_Timer()

    Dim index As Integer, unread As Boolean, number As String, timestamp As String, msg As String

    'Check the incoming message queue
    'If there is a new message, the index of the message will be stored in index
    If MM.CheckMessages(index) Then
    
        'Set to text mode and read message
        MM.SetCharacterSet "PCCP437"
        MM.ReadMessage index, unread, number, timestamp, msg
        
        'Add message to Message List
        UpdateMessageList index, unread, FormatPhoneNumber(number), timestamp, msg
        
        'Auto reply if checked
        If uxAutoReply.Value = 1 Then MM.SendMessage number, "Message Received Successfully at " & Now & ": " & Left(msg, 10) & "..."
    
    End If

End Sub



'************************************************
'* Private Sub CheckListMessagesTimer_Timer()
'* Summary:     Check the list message queue for messages
'*              Timer is enabled from ListMessages
'************************************************
Private Sub CheckListMessagesTimer_Timer()

    Dim index As Integer, unread As Boolean, number As String, timestamp As String, msg As String

    'Add message to Message List
    If MM.CheckListMessages(index, unread, number, timestamp, msg) Then
    
        listMessagesLastTime = Timer
        UpdateMessageList index, unread, FormatPhoneNumber(number), timestamp, msg
    
    End If
    
    'Assume there are no more messages if it has been
    'ListMessageTimeout milliseconds since the last message
    If (listMessagesLastTime + (ListMessagesTimeout / 1000)) < Timer Then
    
        CheckListMessagesTimer.Enabled = False
    
    End If

End Sub



'************************************************
'* Private Sub SignalQualityTimer_Timer()
'* Summary:     Check the list message queue for messages
'*              Timer is enabled from ListMessages
'************************************************
Private Sub SignalQualityTimer_Timer()

    Dim strength As Integer
    Dim color As Long

    If Not MM.GetSignalQuality(strength) Then Exit Sub
    
    'Clear picture box
    uxSignalBox.Cls
    
    If strength = 99 Then
        uxSignalLabel = "NS"        'No Signal
        Exit Sub
    Else
        uxSignalLabel = strength
    End If
    
    'Pick a color based on signal strength
    color = RGB(255, 0, 0)                          'Red
    If strength > 6 Then color = RGB(255, 127, 0)   'Orange
    If strength > 12 Then color = RGB(0, 255, 0)    'Green
 
    'Display signal bars
    If strength > 0 Then uxSignalBox.Line (1, 16)-(3, 13), color, BF
    If strength > 6 Then uxSignalBox.Line (5, 16)-(7, 10), color, BF
    If strength > 12 Then uxSignalBox.Line (9, 16)-(11, 7), color, BF
    If strength > 18 Then uxSignalBox.Line (13, 16)-(15, 4), color, BF
    If strength > 24 Then uxSignalBox.Line (17, 16)-(19, 1), color, BF
    
End Sub



'************************************************
'* Private Sub CreateColumnHeaders()
'* Summary:     Creates column headers for the Message List
'************************************************
Private Sub CreateColumnHeaders()

    'Clear column headers
    uxMessageList.ColumnHeaders.Clear
    
    'Create column headers
    uxMessageList.ColumnHeaders.Add , , "Index", 50
    uxMessageList.ColumnHeaders.Add , , "Status", 60
    uxMessageList.ColumnHeaders.Add , , "From", 100
    uxMessageList.ColumnHeaders.Add , , "Sent", 120
    uxMessageList.ColumnHeaders.Add , , "Message", 250

End Sub



'************************************************
'* Private Function FormatPhoneNumber(number As String)
'* Summary:     Formats a 10 or 11 digit phone number
'* Parameters:  number - phone number to format
'************************************************
Private Function FormatPhoneNumber(number As String)

    If Len(number) = 10 Then
        FormatPhoneNumber = Mid(number, 1, 3) & "-" & _
                            Mid(number, 4, 3) & "-" & _
                            Mid(number, 7, 4)
    ElseIf Len(number) = 11 Then
        FormatPhoneNumber = Mid(number, 1, 1) & "-" & _
                            Mid(number, 2, 3) & "-" & _
                            Mid(number, 5, 3) & "-" & _
                            Mid(number, 8, 4)
    Else
        FormatPhoneNumber = number
    End If

End Function



'************************************************
'* Private Sub ListMessages
'* Summary:     Lists saved messages
'************************************************
Private Sub ListMessages()

    'Disable Check Messages Timer
    CheckMessagesTimer.Enabled = False
    SignalQualityTimer.Enabled = False

    'Set character set to PCCP437 (text, not Hex) and List messages
    MM.SetCharacterSet "PCCP437"
    MM.ListMessages

    listMessagesLastTime = Timer
    
    'Enable timer to read messages from ListMessages
    CheckListMessagesTimer.Interval = 100
    CheckListMessagesTimer.Enabled = True
    
    'Wait for messages
    While CheckListMessagesTimer.Enabled = True
        DoEvents
    Wend
    
    'Enable Check Messages Timer
    CheckMessagesTimer.Enabled = True
    SignalQualityTimer.Enabled = True
    
    SignalQualityTimer_Timer

End Sub



'************************************************
'* Private Sub SetButtons(enable As Boolean)
'* Summary:     Grays out ore enables buttons
'* Parameters:  enable - True to enable, False to disable
'************************************************
Private Sub SetButtons(enable As Boolean)

    If enable Then

        uxDisconnectButton.Enabled = True
        uxRefreshButton.Enabled = True
        uxViewButton.Enabled = True
        uxCreateButton.Enabled = True
        uxDeleteButton.Enabled = True
        uxSynchronizeClockMenuItem.Enabled = True
        uxInfoMenuItem.Enabled = True
        
    Else

        uxDisconnectButton.Enabled = False
        uxRefreshButton.Enabled = False
        uxViewButton.Enabled = False
        uxCreateButton.Enabled = False
        uxDeleteButton.Enabled = False
        uxSynchronizeClockMenuItem.Enabled = False
        uxInfoMenuItem.Enabled = False
        
    End If

End Sub



'************************************************
'* Private Sub UpdateMessageList(index As Integer, unread As Boolean,
'*             number As String, timestamp As String, msg As String)
'* Summary:     Adds a message to the Message List
'* Parameters:  index - index of message
'*              unread - whether or not message has been read
'*              timestamp - time of message
'*              msg - contents of message
'************************************************
Private Sub UpdateMessageList(index As Integer, unread As Boolean, number As String, timestamp As String, msg As String)

    Dim li As ListItem
    Dim i As Integer
    Dim found As Boolean
    
    found = False
    
    'Update message if already in list
    For i = 1 To uxMessageList.ListItems.Count

        If uxMessageList.ListItems.Item(i).Text = index Then

            uxStatusBar.Caption = "Updating Index " & index & "..."

            uxMessageList.ListItems.Item(i).SubItems(1) = IIf(unread, "Unread", "Read")
            uxMessageList.ListItems.Item(i).SubItems(2) = number
            uxMessageList.ListItems.Item(i).SubItems(3) = timestamp
            uxMessageList.ListItems.Item(i).SubItems(4) = msg

            found = True

            Exit For

        End If

    Next

    'Add to list if not already in list
    If Not found Then

        uxStatusBar.Caption = "Updating Index " & index & "..."
        
        Set li = uxMessageList.ListItems.Add(, , index)

        li.SubItems(1) = IIf(unread, "Unread", "Read")
        li.SubItems(2) = number
        li.SubItems(3) = timestamp
        li.SubItems(4) = msg

    End If


End Sub
    
